import { Component, OnInit, Output, EventEmitter, Input, ContentChild, ElementRef, OnChanges, DoCheck, SimpleChanges, AfterContentInit, AfterContentChecked, AfterViewInit, AfterViewChecked } from '@angular/core';
import { User } from '../models/user.model';
import { UsersService } from '../services/users.service';
import { NgModel, NgForm, FormGroup, FormControl, Validators, FormArray, ValidatorFn, AbstractControlOptions, ValidationErrors, FormBuilder } from '@angular/forms';
import { Observable } from 'rxjs';
import { delay } from 'rxjs/operators';
import { MyValidators } from '../myValidators/myValidators';
import { HttpClient } from '@angular/common/http';

@Component({
  selector: 'app-user-form',
  templateUrl: './user-form.component.html',
  styleUrls: ['./user-form.component.sass'],
  styles: [
    `
    input.ng-touched.ng-invalid {border: solid red 3px}
    input.ng-touched.ng-valid {border: solid green 3px}
    `
  ]
})
export class UserFormComponent implements OnInit {

  @Output() onUserAdded: EventEmitter<User> = new EventEmitter<User>(); 


  user: User;
  title: string = "Форма добавления пользователя";

  userForm: FormGroup = new FormGroup({
    "name" : new FormControl("John",[
        Validators.required
    ]
    ),
    "age" : new FormControl("",[
        Validators.required
    ]),

    "account" : new FormGroup({
      "email" : new FormControl("",[
          Validators.required, Validators.email
      ]),
      "password" : new FormControl("",[
          Validators.required
      ]),
    })

  });
  constructor(private userService: UsersService) { 
    this.user =  new User('John',15,'test@test.com','12345');

  }
  ngOnInit(): void {
    
  }

  onSubmit() {

    
    
    //this.userForm.reset();

  }

}
