import { Component, OnInit, Input, OnDestroy, Output, EventEmitter } from '@angular/core';
import { User } from '../models/user.model';
import { UsersService } from '../services/users.service';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs';

import {switchMap} from "rxjs/operators";


@Component({
  selector: 'app-user',
  templateUrl: './user.component.html',
  styleUrls: ['./user.component.sass'],
})
export class UserComponent implements OnInit, OnDestroy {

  @Input('myUser') user: User;
  @Input('ind') ind: number;

  @Output() onUserEditted: EventEmitter<{user:User, name:string}> = new EventEmitter<{user:User, name:string}>(); 
  @Output() onUserDeleted: EventEmitter<User> = new EventEmitter<User>(); 

  id: number;
  param1:string;
  param2: string;

  
  private subsc: Subscription;
  private subscQueryString: Subscription;
  constructor(private activateRoute: ActivatedRoute, private userService: UsersService) { 
      //this.subsc = activateRoute.params.subscribe(params => this.id = params['nmb']);
      this.subsc = activateRoute.paramMap.pipe(switchMap(params => params.getAll('nmb'))).subscribe(params => this.id = parseInt(params));

      this.subscQueryString = activateRoute.queryParams.subscribe((queryParam: any) =>{
        this.param1 = queryParam['param1']
        this.param2 = queryParam['param2']
      });


  }

  ngOnInit(): void {
    if(!this.user) {
      this.user = this.userService.getUser(this.id);
    }

    
  }

  ngOnDestroy() {
    
    this.subsc = null;
  }

  

  

}
