import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { User } from '../models/user.model';
import { UserComponent } from '../user/user.component';
import { UserFormComponent } from '../user-form/user-form.component';
import { UsersService } from '../services/users.service';
import { LogService } from '../services/log.service';
import { ComponentCanDeactivate } from '../guards/exitUsers.guard';
import { Observable } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import { map } from 'rxjs/operators';

@Component({
  selector: 'app-users',
  templateUrl: './users.component.html',
  styleUrls: ['./users.component.sass']
})
export class UsersComponent implements OnInit {

  title: string = "Список пользователей";
  user: User;

  users: User[] = [];



  isFilterAge: boolean = false;
  searchName: string = "";

  constructor(private userService: UsersService, private http: HttpClient) { 
    
  }
  
  
  ngOnInit(): void {
    this.http.get<User[]>('http://ang.loc/api/users').pipe(map((data)=>{return data['users']})).subscribe((response : User[])=>{
      this.users = response;
    });
  }

  onUserAdded($user: User) {
    
  }

}
